/* 
   Read data from daily-return data;  
   Regress with ff-3 factor model and compute the squared residuals as idiosyncratic volatility; 
   Regress with 1-factor model and compute the squared residuals; 
   
*/


libname lib 'C:\QE_MS_1528';


proc sort data=lib.crsp90yr_merged; by permno year month day;


******************* One factor model ***********************************************************;

proc reg noprint data=lib.crsp90yr_merged  outest=reg_results_1ff;
     model ret1 = mkt_rf /ADJRSQ;  *//1 factor model//;
     by permno year month;
run;

data reg_results_1ff;
set reg_results_1ff;
IVOL_1ff = _rmse_**2;  *//compute the idiosyncratic volatility as the squared residuals from the 1 factor model//;
ADJRSQ_1ff = _ADJRSQ_; *//compute the adjusted R-squared from the 1 factor model//;
keep permno year month IVOL_1ff ADJRSQ_1ff; 
run;


Proc sort data=reg_results_1ff; by permno year month ;

data lib.IVOL_mkt;  
set reg_results_1ff;
by permno year month;
run;



