libname folder 'C:\QE_MS_1528';


* compute the average EGARCH-IVOL for each month. Using the 2-step average method;

data IVOL;  ***reading IVOL data***;
set folder.predicted_ivol_trimmed;  
date=intnx('month', date, -1) + day(date) -1;  * find the previous month for each predicted IVOL;
format date mmddyy6.;
run;

proc sort data=ivol;
by date permno;
run;


data crsp_monthly; **Reading market caps from the monthly data set;
set folder.crsp90yr_monthly;
if date2 <= mdy((12),01,2016);
if date2 >= mdy((06),01,1931);
date=date2;
format date3 mmddyy6.; 
keep permno date mkt_value prc0;run;

proc sort data=crsp_monthly;
by date permno;
run;

data try2_1;  **Merging IVOL with market cap;
merge IVOL crsp_monthly;
by date permno;
run;

data try2_1;
set try2_1;
if vhat^=.;
run;



data me_brkpts;
set folder.me_brkpts;
keep date brkpts50;
run;

proc sort data=me_brkpts;
by date;

data try2_2; **Merging with market cap breakpoints (NYSE breakpoints), which are from Ken French's website;
merge try2_1 me_brkpts;
by date;
run;

data try2_2;
set try2_2;
if vhat^=.;

if mkt_value >= brkpts50 then nyse_size_rank = 1; *label the big firms with rank 1, NYSE breakpoints;
else nyse_size_rank = 0;  *label the small firms with rank 0, NYSE breakpoints;


keep date vhat permno mkt_value prc0 nyse_size_rank;
run;

proc sort data=try2_2;
by date nyse_size_rank;

proc means data=try2_2 noprint;
by date;
var vhat;
weight mkt_value;
output out=try4 mean=ivol_averg1;
run;


data folder.average_ivol_VW;
set try4;
date=intnx('month', date, +1) + day(date) -1;  * find the next month for each predicted IVOL;
format date mmddyy6.;
drop _type_ _freq_;
run;
