
libname folder0 'C:\QE_MS_1528';


***reading IVOL data***;
data IVOL;
set folder0.predicted_ivol;  
run;

proc sort data=ivol;
by date;
run;


************************************************************************************;
************************************************************************************;
*trim at +5% level!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!;
************************************************************************************;
************************************************************************************;
************************************************************************************;

proc means data=ivol noprint; * Find the stock number for each month;
by date;
var vhat;
output out=number n=stock_number;run;

data number;
set number;
cut_number=int(stock_number*0.05); * Find the 3% cut-off number for each month;
keep date stock_number cut_number;
run;


proc rank data=ivol out=data302; * Rank the EGARCH IVOL for all stocks each month;
by date;
var vhat;
ranks rank_vhat;
run;


proc sql;
     create table data305
     as select x.*, s.*
     from data302 as s
     left join number as  x
     on s.date=x.date;	 
quit;


data data307;   * Trim the top 3% EGARCH IVOL each month;
set data305;

if rank_vhat < (stock_number - cut_number +1);

drop stock_number cut_number rank_vhat;
run;


data folder0.predicted_ivol_trimmed;  
set data307;
run;
