libname folder 'C:\QE_MS_1528';

* compute the average EGARCH-IVOL for each month. Using the 2-step average method;

data IVOL;  ***reading IVOL data***;
set folder.predicted_ivol_trimmed;  
run;

proc sort data=ivol;
by date permno;
run;


data mv_monthly; **Reading market caps from the monthly data set;
set folder.monthly_data_sw;
if ret_us^=.;

permno=firm_month;

date=mdy(month,01,year);
format date mmddyy6.;

mkt_value = MV_US;

keep permno year month date mkt_value;run;


proc sort data=mv_monthly nodup;
by year month permno;
run;
 
proc univariate data=mv_monthly noprint; var mkt_value; by year month; output out=mvusbreak pctlpts=75 pctlpre=mvusbreak_ pctlname P75 n=nfirm; run;

data data14;
merge mv_monthly mvusbreak; by year month;
if mkt_value<mvusbreak_75 then size=0;
if mkt_value>=mvusbreak_75 then size=1;
keep permno year month date mkt_value size;
run;

 proc sort data=data14 nodup;
 by date permno; run;



data try2_1;  **Merging IVOL with market cap;
merge IVOL data14;
by date permno;
run;

data try2_1;
set try2_1;
if vhat^=.;
if mkt_value^=.;
run;


proc sort data=try2_1;
by date size;

proc means data=try2_1 noprint;
by date size;
var vhat;
weight mkt_value;
output out=try3 mean=ivol_averg0;
run;

proc means data=try3 noprint;
by date;
var ivol_averg0;
output out=try4 mean=ivol_averg1;
run;

data folder.average_ivol;
set try4;
drop _type_ _freq_;
run;
