 
libname folder 'C:\QE_MS_1528';run;


**********************************************************************************************;
**********************************************************************************************;
**********************************************************************************************;
data results_IVOL;
set folder.ivol_over_average;
date=intnx('month', date, -1) + day(date) -1;  * find the prior month for each predicted IVOL;
format date mmddyy6.;
IVOL = ivol_over_average;
keep permno date IVOL;
Proc sort data=results_IVOL nodup; by permno date;run;


*********************************************************************************************;
********************************************************************************************;
 

data monthly;  * CRSP stock data;
set folder.monthly_data_sw;

if ret_us^=.;

permno=firm_month;

date2=mdy(month,01,year);
format date2 mmddyy6.;

ret0=ret_us;

mkt_value = mv_us;

keep permno date2 mkt_value ret0;

run;

Proc sort data=monthly nodup; by permno date2;run;


*******************************************************************;
data data100;  * CRSP return data;
set monthly;
if ret0>=-1;  *keep only valid return observations, will be used below for finding next month returns;
keep permno date2 ret0;
run;
*********************************************************************************************;
**********************************************************************************************;

data cond_beta_all;  * CRSP stock data;
set folder.cond_beta_all;
date4=date;
format date4 mmddyy6.;
drop date;
Proc sort data=cond_beta_all nodup; by permno date4;run;
*********************************************************************************************;
**********************************************************************************************;

**********************************************************************************************;
**********************************************************************************************;



************************************************************************************************************;
************************************************************************************************************;
*The loop should start at here;
************************************************************************************************************;
************************************************************************************************************;
%MACRO DO_MEAN;
%DO I = 0 %TO 359; 

proc printto log="nul:"; run;
**********************************************************************************************;
**********************************************************************************************;
**********************************************************************************************;

data data11a;
set results_IVOL;

date3_old=mdy((12),01,1984);
date3=intnx('month', date3_old, &I) + day(date3_old) -1;
format date3 mmddyy6.;

if date=date3;

keep permno IVOL date3;
run;
**********************************************************************************************;


**********************************************************************************************;
**********************************************************************************************;
**********************************************************************************************;

proc sql;
     create table data12
     as select x.*, s.*
     from data11a as s
     left join monthly as  x
     on s.permno = x.permno and s.date3=x.date2;
quit;

data data12;
set data12;
*if prc0 >= 1; ****remove price less than $1 dollar;
if permno^=.;
keep permno IVOL date3 mkt_value;

proc sort data=data12 nodup; by permno;
run;

data data12;
set data12;
date2_old=mdy((01),01,1985);
date2=intnx('month', date2_old, &I) + day(date2_old) -1;
format date2 mmddyy6.;
run;


proc sort data=data12 nodup; by permno;
run;
 

**********************************************************************************************;
**********************************************************************************************;
**********************************************************************************************;
**********************************************************************************************;
*To merge with returns and prior month returns, momentum, BE/ME ratio;
**********************************************************************************************;
**********************************************************************************************;

proc sql;
     create table data15
     as select x.*, s.*
     from data12 as s
     left join data100 as  x
     on s.permno = x.permno and s.date2=x.date2;	 
quit;

data data15;
set data15;
if permno^=.;
if ret0^=.;

proc sort data=data15 nodup; by permno;
run;


proc sql;
     create table data16
     as select x.*, s.*
     from data15 as s
     left join cond_beta_all as  x
     on s.permno = x.permno and s.date3=x.date4;	 
quit;

data data16;
set data16;
if permno^=.;
if beta^=.;
drop date4;

proc sort data=data16 nodup; by permno;
run;



**********************************************************************************************;
* merging finished;
**********************************************************************************************;


data data18;  
set data16;

if ret0 <= 10;  */Remove return>1000% observations; 

run;

************************************************************************************;



************************************************************************************;
************************************************************************************;
*FAMA and MACBETH regressions start;
************************************************************************************;
************************************************************************************;
************************************************************************************;

proc model data=data18 noprint;
 ret0 = a + b*IVOL + c*beta; 

 h.ret0 = 1;
fit ret0 / outest=reg_results1_5;

data reg_results2_5;
set reg_results1_5;

slope_ivol=b;
slope_beta=c;

date3_old=mdy((12),01,1984);
date3=intnx('month', date3_old, &I) + day(date3_old) -1;
format date3 mmddyy6.;

keep date3 slope_ivol slope_beta;
run;

proc printto;  run;

PROC APPEND BASE=folder.reg_results_2ew_ratio DATA=reg_results2_5;


*********************************************************************************;

************************************************************************************;
************************************************************************************;

proc model data=data18 noprint;
 ret0 = a + b*IVOL + c*beta; 

 h.ret0 = mkt_value;
fit ret0 / outest=reg_results1_5;

data reg_results2_5;
set reg_results1_5;

slope_ivol=b;
slope_beta=c;

date3_old=mdy((12),01,1984);
date3=intnx('month', date3_old, &I) + day(date3_old) -1;
format date3 mmddyy6.;

keep date3 slope_ivol slope_beta;
run;

proc printto;  run;

PROC APPEND BASE=folder.reg_results_2vw_ratio DATA=reg_results2_5;


*********************************************************************************;
*********************************************************************************
*********************************************************************************;
*********************************************************************************;


%END;
%MEND DO_MEAN;

%do_mean

run;





******************************************************************;
